with Ada.Numerics.Elementary_Functions;with Ada.Text_IO;
use  Ada.Numerics.Elementary_Functions;
use  Ada.Text_IO;

package body BinaryTree is


   procedure Preorder (T: in BTree) is
   begin
      Preorder(T, 1);
   end Preorder;
   
   procedure Preorder (T: in BTree; Actual: in Natural) is
   begin
      if Actual < T.Exist'Last+1 then
         if T.Exist(Actual) then
            Put(Integer'Image(T.Item(Actual)) & " ");
            Preorder(T, Actual*2);
            Preorder(T, Actual*2+1);
         else
            Put("null");
         end if;
      end if;
   end Preorder;


   procedure Inorder (T: in BTree) is
   begin
      Inorder(T, 1);
   end Inorder;

   procedure Inorder (T: in BTree; Actual: Natural) is
   begin
      if Actual < T.Exist'Last+1 then
         if T.Exist(Actual) then
            Inorder(T, Actual*2);
            Put(Integer'Image(T.Item(Actual)) & " ");
            Inorder(T, Actual*2+1);
         else
            Put("null");
         end if;
      end if;
   end Inorder;

   
   procedure Postorder (T: in BTree) is
   begin
      Postorder(T, 1);
   end Postorder;
   
   procedure Postorder (T: in BTree; Actual: Natural) is
   begin
      if Actual < T.Exist'Last+1 then
         if T.Exist(Actual) then
            Postorder(T, Actual*2);
            Postorder(T, Actual*2+1);
            Put(Integer'Image(T.Item(Actual)) & " ");
         else
            Put("null ");
         end if;
      end if;
   end Postorder;

   
   procedure Insert (T: in out BTree; Where: in Natural; What: in Integer) is
      I: Natural := 1;
      K: Natural := 1;
   begin
      while K/=Where loop
         if I*2 < T.Item'Last+1 then
            I:=I*2; K:=K+1;
         else
            if I+1 < T.Item'Last+1 then
               I:=I+1; K:=K+1;
               if K /= Where then
                  I:=I/2+1;
                  K:=K+1;
               end if;
            end if;
         end if;
      end loop;
      T.Item(I):=What;
      T.Exist(I):=True;
   end Insert;


   function Count(T: BTree) return Natural is
      C: Natural := 0;
   begin
      for I in T.Exist'range loop
         if T.Exist(I) then C:=C+1; end if;
      end loop;
      return C;
   end Count;
   

   function Height (T: BTree) return Natural is
      H: Natural;
      I: Natural;
   begin
      I:=T.Exist'Last;
      while not T.Exist(I) loop
         I:=I-1;
      end loop;
      H:=Natural(Sqrt(Float(I)));
      return H;
   end Height;
   

end BinaryTree;