
package BinaryTree is

   -- eldefinci   
   N : Natural;
   type BTree (N: Natural) is private;

   -- funkcik s eljrsok   
   procedure Preorder   (T: in BTree);
   procedure Inorder    (T: in BTree);
   procedure Postorder  (T: in BTree);
   procedure Insert     (T: in out BTree; Where: in Natural; What: in Integer);
   
   function Count        (T: BTree) return Natural;
   function Height      (T: BTree) return Natural;
   

   -- bels tpusok
   private
   
   type TreeData    is array (Natural range <>) of Integer;
   type TreeLogical is array (Natural range <>) of Boolean;
   type BTree (N: Natural) is record
      Item  : TreeData    (1..N);
      Exist : TreeLogical (1..N) := (others => False);
   end record;
   
   procedure Preorder   (T: in BTree; Actual: in Natural);
   procedure Inorder    (T: in BTree; Actual: in Natural);
   procedure Postorder  (T: in BTree; Actual: in Natural);
   

end BinaryTree;
